/*
 * Block.cpp
 *
 *  Created on: Feb 14, 2015
 *      Author: rmin
 */

#include "Block.h"

Block::Block(StaticData &staticData) :
		Block(staticData.getId(), staticData.getTurn(), staticData.getType(),
				staticData.getPosition(),
				staticData.getOther().getAsInt("height"),
				staticData.getOther().getAsInt("resource")) {

}

Block::Block(std::string id, int turn, std::string type, Position pos,
		int height, int resource) {
	this->id = id;
	this->turn = turn;
	this->type = type;
	this->pos = pos;
	this->height = height;
	this->resource = resource;
}

Block::~Block() {
	// TODO Auto-generated destructor stub
}

void Block::setChange(StaticData &staticData) {
	this->pos = staticData.getPosition();
	this->height = staticData.getOther().getAsInt("height");
	this->resource = staticData.getOther().getAsInt("resource");
	this->turn = staticData.getTurn();
	this->type = staticData.getType();
	this->id = staticData.getId();
}

Position Block::getPos() {
	return pos;
}

int Block::getHeight() {
	return height;
}

int Block::getResource() {
	return resource;
}

std::string Block::getType() {
	return type;
}

std::string Block::getId() {
	return id;
}

int Block::getTurn() {
	return turn;
}
