/*
 * Cell.cpp
 *
 *  Created on: Feb 14, 2015
 *      Author: rmin
 */

#include "Cell.h"
#include <chrono>

Cell::Cell(EventHandler* eventHandler, DynamicData &dynamicData) {
	this->eventHandler = eventHandler;
	mId = dynamicData.getId();
	mPos = dynamicData.getPosition();
	mTeamId = dynamicData.getOther().getAsInt("teamId");
	mEnergy = dynamicData.getOther().getAsInt("energy");
}

Cell::Cell(std::string id, Position pos, int teamId, int energy) {
	eventHandler = NULL;
	mId = id;
	mPos = pos;
	mTeamId = teamId;
	mEnergy = energy;
}

void Cell::move(Direction direction) {

//	auto start = std::chrono::steady_clock::now();
	GameEvent* event = new GameEvent(GameEvent::TYPE_MOVE);
	event->setObjectId(mId);
	event->addArg(DirectionStr[direction]);

	eventHandler->addEvent(event);
//	auto end = std::chrono::steady_clock::now();
//	auto diff = end - start;
//	std::cerr << "Duration of Cell Move: "
//			<< std::chrono::duration<double, std::milli>(diff).count()
//			<< std::endl;
}

void Cell::gainResource() {
//	auto start = std::chrono::steady_clock::now();
	GameEvent *event = new GameEvent(GameEvent::TYPE_GAIN_RESOURCE);
	event->setObjectId(mId);

	eventHandler->addEvent(event);
//	auto end = std::chrono::steady_clock::now();
//	auto diff = end - start;
//	std::cerr << "Duration of Cell Gain Resource: "
//			<< std::chrono::duration<double, std::milli>(diff).count()
//			<< std::endl;
}

void Cell::mitosis() {
//	auto start = std::chrono::steady_clock::now();
	GameEvent *event = new GameEvent(GameEvent::TYPE_MITOSIS);
	event->setObjectId(mId);

	eventHandler->addEvent(event);
//	auto end = std::chrono::steady_clock::now();
//	auto diff = end - start;
//	std::cerr << "Duration of Cell Mitosis: "
//			<< std::chrono::duration<double, std::milli>(diff).count()
//			<< std::endl;
}

std::string Cell::getId() {
	return mId;
}

Position Cell::getPos() {
	return mPos;
}

int Cell::getTeamId() {
	return mTeamId;
}

int Cell::getEnergy() {
	return mEnergy;
}

Cell::~Cell() {
	// TODO Auto-generated destructor stub
}

