/*
 * Cell.h
 *
 *  Created on: Feb 14, 2015
 *      Author: rmin
 */

#ifndef CELL_H_
#define CELL_H_

#include "GameEvent.h"
#include "DynamicData.h"
#include "Position.h"
#include "EventHandler.h"
#include <string>
#include "Direction.h"

class Cell {
public:
	std::string DirectionStr[6] = { "NORTH", "SOUTH", "NORTH_EAST",
			"NORTH_WEST", "SOUTH_EAST", "SOUTH_WEST" };

private:
	EventHandler* eventHandler;
	std::string mId;
	Position mPos;
	int mTeamId;
	int mEnergy;
public:
	Cell(EventHandler* eventHandler, DynamicData &dynamicData);
	Cell(std::string id = "", Position pos = Position(0,0), int teamId = 0, int energy = 0);
	void move(Direction direction);
	void gainResource();
	void mitosis();
	std::string getId();
	Position getPos();
	int getTeamId();
	int getEnergy();
	virtual ~Cell();
};

#endif /* CELL_H_ */
