/*
 * Json.cpp
 *
 *  Created on: Feb 4, 2015
 *      Author: rmin
 */

#include "Message.h"
#include <chrono>

Message::Message() {
	// TODO Auto-generated constructor stub
}

Message::~Message() {
	// TODO Auto-generated destructor stub
}

void Message::setJson(std::string str) {
	std::stringstream tmp(str);
	boost::property_tree::read_json(tmp, jsonTree);

}

std::string Message::getJson() {
	std::ostringstream output;
	boost::property_tree::write_json(output, jsonTree, false);
	output << '\0';
	return output.str();
}

std::string Message::getAsString(std::string node) {
	return jsonTree.get<std::string>(node);
}

Message Message::getAsMessage(std::string str) {
	Message msg;
	BOOST_FOREACH(boost::property_tree::ptree::value_type& node, jsonTree.get_child(str)) {
		msg.addNode(node.first, node.second.data());
	}
	return msg;
}

int Message::getAsInt(std::string node) {
	return atoi(jsonTree.get<std::string>(node).c_str());
}

std::string Message::getName() {
	// Json
	return getAsString("name");
}

void Message::addNode(std::string name, std::string value) {
	jsonTree.add(name, value);
}

void Message::addNode(std::string name, int value) {
	jsonTree.add(name, value);
}

void Message::addArray(std::string name, std::vector<std::string> value) {
	boost::property_tree::ptree children;
	if (value.empty()) {
		value.push_back("SALAM");
	}
	for (int i = 0; i < (int) value.size(); i++) {
		boost::property_tree::ptree child;
		child.put("", value[i]);
		children.push_back(std::make_pair("", child));
	}
	jsonTree.add_child(name, children);
}

void Message::addArray(std::string name, std::vector<Message> value) {
	boost::property_tree::ptree children;
	if (value.empty()) {
		Message msg;
		msg.addNode("S", "K");
		value.push_back(msg);
	}
	for (int i = 0; i < (int) value.size(); i++) {
//		boost::property_tree::ptree child;
//		child.put("", value[i]);
		children.push_back(std::make_pair("", value[i].getJsonTree()));
	}
	jsonTree.add_child(name, children);
}

std::vector<Message> Message::getArray(std::string str, bool isTurn) {
	std::vector<Message> array;
	int counter = 0;
	BOOST_FOREACH(boost::property_tree::ptree::value_type& node,jsonTree.get_child(str)) {
		Message msg;
		std::string str = "{ \"node\": ";
		std::ostringstream stream;

		if (isTurn && counter == 0) {
			stream << "{\"turn\" :";
			stream << node.second.data();
			stream << "}";
		} else {
			boost::property_tree::write_json(stream, node.second, false);
		}
		str += stream.str();
		str += "}";
		counter++;
		msg.setJson(str);
		array.push_back(msg);
	}
	return array;
}

boost::property_tree::ptree Message::getJsonTree() {
	return jsonTree;
}
