/*
 * Message.h
 *
 *  Created on: Feb 4, 2015
 *      Author: rmin
 */

#ifndef MESSAGE_H_
#define MESSAGE_H_

#include <iostream>

#include <boost/locale.hpp>
#include <boost/property_tree/json_parser.hpp>
#include <boost/property_tree/ptree.hpp>
#include <boost/foreach.hpp>

#include <map>
#include <vector>
#include <string>
#include <sstream>

class Message {
private:
	boost::property_tree::ptree jsonTree;
public:
	Message();
	virtual ~Message();
	void setJson(std::string str);
	std::string getJson();
	void addNode(std::string name,std::string value);
	void addNode(std::string name,int value);
	void addArray(std::string name,std::vector<std::string> value);
	void addArray(std::string name, std::vector<Message> value);
	std::string getAsString(std::string node);
	Message getAsMessage(std::string node);
	int getAsInt(std::string node);
	std::string getName();
	boost::property_tree::ptree getJsonTree();
	std::vector<Message> getArray(std::string str,bool isTurn = 0);
};

#endif /* MESSAGE_H_ */
