/*
 * Model.cpp
 *
 *  Created on: Feb 4, 2015
 *      Author: rmin
 */

#include "Model.h"

const std::string GAME_OBJECT_TYPE_CELL = "cell";

Model::Model(EventHandler *eventHandler) {
	// TODO Auto-generated constructor stub
	this->eventHandler = eventHandler;
	turnStartTime = 0;
	turnTimeout = 400;
	world = NULL;
}

Model::~Model() {
	// TODO Auto-generated destructor stub
}

void Model::handleInitMessage(Message msg)
{
	// game developers' todo store data
	Parser parser;

	std::vector<Message> argsArray = msg.getArray("args");

	ClientInitInfo* initInfo = new ClientInitInfo();
	parser.parsClientInitInfo(argsArray[0],*initInfo);

	std::vector<StaticData> staticDataArray;
	std::vector<Message> staticDataMessageArray = argsArray[1].getArray("node");
	for(int i=0;i<(int)staticDataMessageArray.size();i++)
	{
		StaticData *staticData = new StaticData;
		parser.parsStaticData(staticDataMessageArray[i],*staticData);
		staticDataArray.push_back(*staticData);
	}


	Map *map = new Map(initInfo->getMapSize(),staticDataArray);

	// TODO STATIC DIFF

	world = new World(eventHandler,initInfo,map);

	delete initInfo;

}

void Model::handleTurnMessage(Message msg)
{
	turnStartTime = time(0);
	// game developers' todo store data

	Parser parser;

	std::vector<Message> argsArray = msg.getArray("args",true);

	this->world->setTurn(argsArray[0].getAsInt("node.turn"));

	std::vector<Message> staticsArray = argsArray[1].getArray("node.statics");
	std::vector<Message> dynamicsArray = argsArray[1].getArray("node.dynamics");
//	std::vector<Message> transientsArray = argsArray[1].getArray("node.transients");

	for(int i=0;i<(int)staticsArray.size();i++)
	{
		StaticData staticData;
		parser.parsStaticData(staticsArray[i],staticData);
		this->getWorld()->setStaticChange(staticData);
	}

	world->clearDynamics();

	for(int i=0;i<(int)dynamicsArray.size();i++)
	{
		DynamicData dynamicData;
		parser.parsDynamicData(dynamicsArray[i],dynamicData);
		if(dynamicData.getType() == GAME_OBJECT_TYPE_CELL)
		{
			world->addCell(dynamicData);
		}
		else
		{
			// nothing yet!!
		}
	}

	//TODO Transients

	eventHandler->clear();
}

long long Model::getTurnTimeout()
{
	return turnTimeout;
}

long long Model::getTurnTimePassed()
{
	return time(0) - turnStartTime;
}

long long Model::getTurnRemainingTime()
{
	return turnTimeout - getTurnTimePassed();
}

World* Model::getWorld()
{
	return world;
}
