/*
 * Parser.cpp
 *
 *  Created on: Feb 15, 2015
 *      Author: rmin
 */

#include "Parser.h"

Parser::Parser() {
	// TODO Auto-generated constructor stub

}

Parser::~Parser() {
	// TODO Auto-generated destructor stub
}

void Parser::parsStaticData(Message &msg, StaticData &staticData) {
	staticData.setId(msg.getAsString("node.id"));

	staticData.setType(msg.getAsString("node.type"));

	staticData.setTurn(msg.getAsInt("node.turn"));

	Message position = msg.getAsMessage("node.position");
	staticData.setPosition(
			Position(position.getAsInt("x"), position.getAsInt("y")));

	Message other = msg.getAsMessage("node.other");
	staticData.setOther(other);
}

void Parser::parsDynamicData(Message &msg, DynamicData &dynamicData) {
	dynamicData.setId(msg.getAsString("node.id"));

	dynamicData.setType(msg.getAsString("node.type"));

	Message position = msg.getAsMessage("node.position");
	dynamicData.setPosition(
			Position(position.getAsInt("x"), position.getAsInt("y")));

	Message other = msg.getAsMessage("node.other");
	dynamicData.setOther(other);
}

void Parser::parsClientInitInfo(Message &msg, ClientInitInfo &clientInitInfo) {
	clientInitInfo.setTurn(msg.getAsInt("node.turn"));

	BOOST_FOREACH(boost::property_tree::ptree::value_type& node,msg.getJsonTree().get_child("node.teams")) {
		clientInitInfo.addTeam(node.second.data());
	}

	Message yourInfo = msg.getAsMessage("node.yourInfo");
	clientInitInfo.setYourInfo(
			TeamInfo(yourInfo.getAsString("name"), yourInfo.getAsInt("id")));

	Message mapSize = msg.getAsMessage("node.mapSize");
	clientInitInfo.setMapSize(
			MapSize(mapSize.getAsInt("width"), mapSize.getAsInt("height")));
}

void Parser::generateEvent(Message &msg, GameEvent &event) {
	msg.addNode("type", event.getType());
	msg.addNode("objectId", event.getObjectId());
	std::vector<std::string> args;
	for (int i = 0; i < (int) event.getArgs().size(); i++) {
		args.push_back(event.getArgs()[i]);
	}
	msg.addArray("args", args);
}
