/*
 * World.h
 *
 *  Created on: Feb 15, 2015
 *      Author: rmin
 */

#ifndef WORLD_H_
#define WORLD_H_

#include <vector>
#include <string>
#include "MapSize.h"
#include "ClientInitInfo.h"
#include "EventHandler.h"
#include "DynamicData.h"
#include "Cell.h"
#include "Map.h"

class World {
	std::vector<std::string> teams;
	Cell tmp;
	int myId;
	std::string myName;
	MapSize mapSize;
	Map *map;
	int turn;
	std::vector<Cell*> allCells;
	std::vector<Cell*> myCells;
	std::vector<Cell*> enemyCells;
	EventHandler* eventHandler;
public:
	World(EventHandler* eventHandler, ClientInitInfo *initInfo, Map *map);
	virtual ~World();
	void clearDynamic();
	std::vector<std::string>& getTeams();
	int getMyId();
	std::string getMyName();
	MapSize getMapSize();
	Map* getMap();
	int getTurn();
	void setTurn(int turn);
	void clearDynamics();
	void addCell(DynamicData dynamicData);
	std::vector<Cell*> getAllCells();
	std::vector<Cell*> getMyCells();
	std::vector<Cell*> getEnemyCells();
	void setStaticChange(StaticData s);
};

#endif /* WORLD_H_ */
